﻿#pragma strict

//SFXs
public var attackSfx : AudioClip;
public var niceAttack = new AudioClip[3];
public var meanAttack = new AudioClip[3];

//Frames
public var walkingFrame = new Sprite[2];
public var hugAttackFrame = new Sprite[2];
public var strikeAttackFrame = new Sprite[2];
public var strikerFrame = new Sprite[2];
public var huggerFrame = new Sprite[2];

private var speed : float = 1;
private var timer : float = 0;
private var flip : int = 0;
private var huggerOrStriker : String;
private var range : float;
private var player : GameObject;
private var speachTimer : float = 4;
private var isDefeated : boolean;

function Start(){
	speed = (speed * 0.1);
}

function Update () { 
	if (player == null)
		player = GameScript.playerObject;
	
	var distanceToPlayer = Vector3.Distance(player.transform.position, transform.position);
	
	huggerOrStriker = transform.parent.GetComponent(EnemyController).huggerOrStriker;
	isDefeated = transform.parent.GetComponent(EnemyController).isDefeated;
	
	timer += Time.deltaTime;
	
	if (GameScript.gameStatus == "Running" && !isDefeated) {
		speachTimer += Time.deltaTime;
		
		if (distanceToPlayer >= 3)
			Walk();
		else if (distanceToPlayer < 3 && distanceToPlayer >= 1.9)
			Reveal();
		else if (distanceToPlayer < 1.9)
			Attack();
	}
	else if (isDefeated)
		Die();
	else if (GameScript.gameStatus == "GameOver")
		Walk();
}

function Walk(){
	if (timer > speed) {
		GetComponent(SpriteRenderer).sprite = walkingFrame[flip];
		flip = 1 - flip;
		timer = 0;
	}
}

function Reveal () {
	if (timer > speed && huggerOrStriker == "Striker") {
		GetComponent(SpriteRenderer).sprite = strikerFrame[flip];
		flip = 1 - flip;
		timer = 0;
	}
	else if (timer > speed && huggerOrStriker == "Hugger") {
		GetComponent(SpriteRenderer).sprite = huggerFrame[flip];
		flip = 1 - flip;
		timer = 0;
	}
}

function Attack () {
	if (timer > speed && huggerOrStriker == "Striker") {
		SaySomethingMean();
		GetComponent(SpriteRenderer).sprite = strikeAttackFrame[flip];
		flip = 1 - flip;
		timer = 0;
		GameScript.depression += 4;
	}
	else if (timer > speed && huggerOrStriker == "Hugger") {
		SaySomethingNice();
		GetComponent(SpriteRenderer).sprite = hugAttackFrame[flip];
		flip = 1 - flip;
		timer = 0;
		GameScript.depression += 2;
	}
}

function SaySomethingMean () {
	if (speachTimer > 5) {
		audio.PlayOneShot(meanAttack[Random.value * 3]);
		speachTimer = 0;
	}
}

function SaySomethingNice () {
	if (speachTimer > 5) {
		audio.PlayOneShot(niceAttack[Random.value * 3]);
		speachTimer = 0;
	}
}

function Die () {
	GetComponent(SpriteRenderer).color.a -= Time.deltaTime;
	
	if (GetComponent(SpriteRenderer).color.a <= 0)
		Destroy(gameObject);
}

@script RequireComponent(AudioSource);